/* (c) https://github.com/MontiCore/monticore */
// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: simulationController.proto

package protobuf;

/**
 * Protobuf type {@code SimulationController.SetSectorRequest}
 */
public  final class SetSectorRequest extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:SimulationController.SetSectorRequest)
    SetSectorRequestOrBuilder {
private static final long serialVersionUID = 0L;
  // Use SetSectorRequest.newBuilder() to construct.
  private SetSectorRequest(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private SetSectorRequest() {
    osmIDs_ = java.util.Collections.emptyList();
  }

  @java.lang.Override
  public final com.google.protobuf.UnknownFieldSet
  getUnknownFields() {
    return this.unknownFields;
  }
  private SetSectorRequest(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    this();
    if (extensionRegistry == null) {
      throw new java.lang.NullPointerException();
    }
    int mutable_bitField0_ = 0;
    com.google.protobuf.UnknownFieldSet.Builder unknownFields =
        com.google.protobuf.UnknownFieldSet.newBuilder();
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          default: {
            if (!parseUnknownFieldProto3(
                input, unknownFields, extensionRegistry, tag)) {
              done = true;
            }
            break;
          }
          case 8: {
            if (!((mutable_bitField0_ & 0x00000001) == 0x00000001)) {
              osmIDs_ = new java.util.ArrayList<java.lang.Integer>();
              mutable_bitField0_ |= 0x00000001;
            }
            osmIDs_.add(input.readInt32());
            break;
          }
          case 10: {
            int length = input.readRawVarint32();
            int limit = input.pushLimit(length);
            if (!((mutable_bitField0_ & 0x00000001) == 0x00000001) && input.getBytesUntilLimit() > 0) {
              osmIDs_ = new java.util.ArrayList<java.lang.Integer>();
              mutable_bitField0_ |= 0x00000001;
            }
            while (input.getBytesUntilLimit() > 0) {
              osmIDs_.add(input.readInt32());
            }
            input.popLimit(limit);
            break;
          }
        }
      }
    } catch (com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new com.google.protobuf.InvalidProtocolBufferException(
          e).setUnfinishedMessage(this);
    } finally {
      if (((mutable_bitField0_ & 0x00000001) == 0x00000001)) {
        osmIDs_ = java.util.Collections.unmodifiableList(osmIDs_);
      }
      this.unknownFields = unknownFields.build();
      makeExtensionsImmutable();
    }
  }
  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return protobuf.SimulationControllerProto.internal_static_SimulationController_SetSectorRequest_descriptor;
  }

  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return protobuf.SimulationControllerProto.internal_static_SimulationController_SetSectorRequest_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            protobuf.SetSectorRequest.class, protobuf.SetSectorRequest.Builder.class);
  }

  public static final int OSMIDS_FIELD_NUMBER = 1;
  private java.util.List<java.lang.Integer> osmIDs_;
  /**
   * <code>repeated int32 osmIDs = 1;</code>
   */
  public java.util.List<java.lang.Integer>
      getOsmIDsList() {
    return osmIDs_;
  }
  /**
   * <code>repeated int32 osmIDs = 1;</code>
   */
  public int getOsmIDsCount() {
    return osmIDs_.size();
  }
  /**
   * <code>repeated int32 osmIDs = 1;</code>
   */
  public int getOsmIDs(int index) {
    return osmIDs_.get(index);
  }
  private int osmIDsMemoizedSerializedSize = -1;

  private byte memoizedIsInitialized = -1;
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    getSerializedSize();
    if (getOsmIDsList().size() > 0) {
      output.writeUInt32NoTag(10);
      output.writeUInt32NoTag(osmIDsMemoizedSerializedSize);
    }
    for (int i = 0; i < osmIDs_.size(); i++) {
      output.writeInt32NoTag(osmIDs_.get(i));
    }
    unknownFields.writeTo(output);
  }

  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    {
      int dataSize = 0;
      for (int i = 0; i < osmIDs_.size(); i++) {
        dataSize += com.google.protobuf.CodedOutputStream
          .computeInt32SizeNoTag(osmIDs_.get(i));
      }
      size += dataSize;
      if (!getOsmIDsList().isEmpty()) {
        size += 1;
        size += com.google.protobuf.CodedOutputStream
            .computeInt32SizeNoTag(dataSize);
      }
      osmIDsMemoizedSerializedSize = dataSize;
    }
    size += unknownFields.getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof protobuf.SetSectorRequest)) {
      return super.equals(obj);
    }
    protobuf.SetSectorRequest other = (protobuf.SetSectorRequest) obj;

    boolean result = true;
    result = result && getOsmIDsList()
        .equals(other.getOsmIDsList());
    result = result && unknownFields.equals(other.unknownFields);
    return result;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (getOsmIDsCount() > 0) {
      hash = (37 * hash) + OSMIDS_FIELD_NUMBER;
      hash = (53 * hash) + getOsmIDsList().hashCode();
    }
    hash = (29 * hash) + unknownFields.hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static protobuf.SetSectorRequest parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static protobuf.SetSectorRequest parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static protobuf.SetSectorRequest parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static protobuf.SetSectorRequest parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static protobuf.SetSectorRequest parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static protobuf.SetSectorRequest parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static protobuf.SetSectorRequest parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static protobuf.SetSectorRequest parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static protobuf.SetSectorRequest parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static protobuf.SetSectorRequest parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static protobuf.SetSectorRequest parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static protobuf.SetSectorRequest parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(protobuf.SetSectorRequest prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * Protobuf type {@code SimulationController.SetSectorRequest}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:SimulationController.SetSectorRequest)
      protobuf.SetSectorRequestOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return protobuf.SimulationControllerProto.internal_static_SimulationController_SetSectorRequest_descriptor;
    }

    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return protobuf.SimulationControllerProto.internal_static_SimulationController_SetSectorRequest_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              protobuf.SetSectorRequest.class, protobuf.SetSectorRequest.Builder.class);
    }

    // Construct using protobuf.SetSectorRequest.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }
    private void maybeForceBuilderInitialization() {
      if (com.google.protobuf.GeneratedMessageV3
              .alwaysUseFieldBuilders) {
      }
    }
    public Builder clear() {
      super.clear();
      osmIDs_ = java.util.Collections.emptyList();
      bitField0_ = (bitField0_ & ~0x00000001);
      return this;
    }

    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return protobuf.SimulationControllerProto.internal_static_SimulationController_SetSectorRequest_descriptor;
    }

    public protobuf.SetSectorRequest getDefaultInstanceForType() {
      return protobuf.SetSectorRequest.getDefaultInstance();
    }

    public protobuf.SetSectorRequest build() {
      protobuf.SetSectorRequest result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    public protobuf.SetSectorRequest buildPartial() {
      protobuf.SetSectorRequest result = new protobuf.SetSectorRequest(this);
      int from_bitField0_ = bitField0_;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        osmIDs_ = java.util.Collections.unmodifiableList(osmIDs_);
        bitField0_ = (bitField0_ & ~0x00000001);
      }
      result.osmIDs_ = osmIDs_;
      onBuilt();
      return result;
    }

    public Builder clone() {
      return (Builder) super.clone();
    }
    public Builder setField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return (Builder) super.setField(field, value);
    }
    public Builder clearField(
        com.google.protobuf.Descriptors.FieldDescriptor field) {
      return (Builder) super.clearField(field);
    }
    public Builder clearOneof(
        com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return (Builder) super.clearOneof(oneof);
    }
    public Builder setRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        int index, java.lang.Object value) {
      return (Builder) super.setRepeatedField(field, index, value);
    }
    public Builder addRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return (Builder) super.addRepeatedField(field, value);
    }
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof protobuf.SetSectorRequest) {
        return mergeFrom((protobuf.SetSectorRequest)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(protobuf.SetSectorRequest other) {
      if (other == protobuf.SetSectorRequest.getDefaultInstance()) return this;
      if (!other.osmIDs_.isEmpty()) {
        if (osmIDs_.isEmpty()) {
          osmIDs_ = other.osmIDs_;
          bitField0_ = (bitField0_ & ~0x00000001);
        } else {
          ensureOsmIDsIsMutable();
          osmIDs_.addAll(other.osmIDs_);
        }
        onChanged();
      }
      this.mergeUnknownFields(other.unknownFields);
      onChanged();
      return this;
    }

    public final boolean isInitialized() {
      return true;
    }

    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      protobuf.SetSectorRequest parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (protobuf.SetSectorRequest) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }
    private int bitField0_;

    private java.util.List<java.lang.Integer> osmIDs_ = java.util.Collections.emptyList();
    private void ensureOsmIDsIsMutable() {
      if (!((bitField0_ & 0x00000001) == 0x00000001)) {
        osmIDs_ = new java.util.ArrayList<java.lang.Integer>(osmIDs_);
        bitField0_ |= 0x00000001;
       }
    }
    /**
     * <code>repeated int32 osmIDs = 1;</code>
     */
    public java.util.List<java.lang.Integer>
        getOsmIDsList() {
      return java.util.Collections.unmodifiableList(osmIDs_);
    }
    /**
     * <code>repeated int32 osmIDs = 1;</code>
     */
    public int getOsmIDsCount() {
      return osmIDs_.size();
    }
    /**
     * <code>repeated int32 osmIDs = 1;</code>
     */
    public int getOsmIDs(int index) {
      return osmIDs_.get(index);
    }
    /**
     * <code>repeated int32 osmIDs = 1;</code>
     */
    public Builder setOsmIDs(
        int index, int value) {
      ensureOsmIDsIsMutable();
      osmIDs_.set(index, value);
      onChanged();
      return this;
    }
    /**
     * <code>repeated int32 osmIDs = 1;</code>
     */
    public Builder addOsmIDs(int value) {
      ensureOsmIDsIsMutable();
      osmIDs_.add(value);
      onChanged();
      return this;
    }
    /**
     * <code>repeated int32 osmIDs = 1;</code>
     */
    public Builder addAllOsmIDs(
        java.lang.Iterable<? extends java.lang.Integer> values) {
      ensureOsmIDsIsMutable();
      com.google.protobuf.AbstractMessageLite.Builder.addAll(
          values, osmIDs_);
      onChanged();
      return this;
    }
    /**
     * <code>repeated int32 osmIDs = 1;</code>
     */
    public Builder clearOsmIDs() {
      osmIDs_ = java.util.Collections.emptyList();
      bitField0_ = (bitField0_ & ~0x00000001);
      onChanged();
      return this;
    }
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFieldsProto3(unknownFields);
    }

    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:SimulationController.SetSectorRequest)
  }

  // @@protoc_insertion_point(class_scope:SimulationController.SetSectorRequest)
  private static final protobuf.SetSectorRequest DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new protobuf.SetSectorRequest();
  }

  public static protobuf.SetSectorRequest getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<SetSectorRequest>
      PARSER = new com.google.protobuf.AbstractParser<SetSectorRequest>() {
    public SetSectorRequest parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return new SetSectorRequest(input, extensionRegistry);
    }
  };

  public static com.google.protobuf.Parser<SetSectorRequest> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<SetSectorRequest> getParserForType() {
    return PARSER;
  }

  public protobuf.SetSectorRequest getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

